/* 

Copyright 2006: Irmtraud M. Meyer (irmtraud.meyer@cantab.net) and Istvan Miklos 

This file is free software; you can redistribute it and/or
modify it under the terms of the GNU Library General Public
License as published by the Free Software Foundation.
See http://www.gnu.org/copyleft/gpl.html for more information.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Library General Public License for more details.
You should have received a copy of the GNU Library General Public
License along with this library; if not, write to the Free
Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

*/

#ifndef _glib_h
#define _glib_h

#include "global.h"

void AddEdge(Graph g, int n, int m, int label);
Edge FindEdge(Graph graph, int i, int j);
int RemoveEdge(Graph graph, Edge edge);
int NumEdges(Graph g);
Graph NewGraph(int size);
EuclidGraph NewEuclid(int size);
MatrixGraph NewMatrix(int size);
Graph CopyGraph(Graph g);
Graph ReadGraphAsUpperTriangle (int* size, char file[]);
Graph ReadGraph (int* size, char file[]);
void WriteGraph (Graph graph, char file[]);
EuclidGraph ReadEuclid(int* size, char file[]);
void WriteEuclid(EuclidGraph graph, char file[]);
MatrixGraph ReadMatrix(int* size, char file[]);
void WriteMatrix(MatrixGraph graph, char file[]);
int eucdist (EuclidGraph graph, int i, int j);
int eucdist2 (EuclidGraph graph, int i, int j);
int eucdistsq(EuclidGraph graph, int i, int j);
Graph ConvertBpairsToGraph(const int iNodes, const int iEdges, const INFO* infPairs);

#endif
