/* 

Copyright 2006: Irmtraud M. Meyer (irmtraud.meyer@cantab.net) and Istvan Miklos 

This file is free software; you can redistribute it and/or
modify it under the terms of the GNU Library General Public
License as published by the Free Software Foundation.
See http://www.gnu.org/copyleft/gpl.html for more information.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Library General Public License for more details.
You should have received a copy of the GNU Library General Public
License along with this library; if not, write to the Free
Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

*/

#ifndef _mwm_define_h
#define _mwm_define_h

#define	MAXWT  1000000

/* the number of the blossom entered by edge e */
#define BEND(e) (BASE[END[e]])

/* the blossom matched with v's blossom */
#define BMATE(v) (BASE[END[MATE[v]]])

/* the blossom entered by the edge that links v's blossom */
#define BLINK(v) (BASE[END[LINK[v]]])

/* the edge e with it's direction reversed */
#define OPPEDGE(e) (((e - U) % 2 == 0) ? (e - 1) : (e + 1))

/* the slack of edge e */
#define SLACK(e) (Y[END[e]] + Y[END[OPPEDGE(e)]] - WEIGHT[e])

/* Global variables */

extern int *A,*END,*WEIGHT,*NEXTPAIR;
extern int *MATE,*LINK,*BASE,*NEXTVTX,*LASTVTX,*Y,*NEXT_D,*NEXTEDGE;

extern int LAST_D, DELTA;

extern int LASTEDGE[3];

extern int DUMMYVERTEX, DUMMYEDGE;
extern int U, V;

extern int newbase, oldbase, nextbase, stopscan, pairpoint;
extern int neighbor, nextpoint, newlast;
extern int newmate, oldmate, oldfirst, firstmate, secondmate;
extern int f, nextedge, nexte, nextu;

extern int v,i,e;

#endif
