/* 

Copyright 2006: Irmtraud M. Meyer (irmtraud.meyer@cantab.net) and Istvan Miklos 

Some of these functions are based on functions of the HXMATCH software package
by Christina Witwer, see http://www.tbi.univie.ac.at/papers/SUPPLEMENTS/HXMATCH/ 
for more information and a link to the HXMATCH software. 

This file is free software; you can redistribute it and/or
modify it under the terms of the GNU Library General Public
License as published by the Free Software Foundation.
See http://www.gnu.org/copyleft/gpl.html for more information.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Library General Public License for more details.
You should have received a copy of the GNU Library General Public
License along with this library; if not, write to the Free
Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

*/

#ifndef _process_h
#define _process_h

INFO* InitializeINFO(INFO *inf, const int f, const int p); 
int cmp_bi(const void *i1, const void *i2); 
int cmp_bj(const void *j1, const void *j2); 
int cmp_xx(const void *t1, const void *t2); 
int cmp_fct2(const void *t1, const void *t2); 
int cmp_stwt(const void *sw1, const void *sw2); 
int cmp_stbi(const void *si1, const void *si2); 

void ModifyBPWeights(void); 
void GenerateHelices(void); 
void GetHelix(const int ii, const int ij, int* iHL, int* iHW); 
void SelectBpairsInHelices(void); 
void DeleteHelicesAndIndices(void); 

void MarkBpairs(int* iN_BP, INFO** infBP); 
void ExtendStacks(const int iRefN, const INFO *infRefBpairs, int* iN, INFO** infBpairs); 
int  PostProcess(const int iN, const int* iMate, int* iNE, INFO** infBP, char** cStrucString); 
void GetStacks(int* iNBP, INFO** infBP, int* iN, STACK** stStacks);  
void ColorStacks(const int* iS, STACK** stStacks);  
void ColorBpairs(const int iS, const STACK* stStacks, const int* iNBP, INFO** infBP); 
void GetNewBpairs(const int iNBP, const INFO *infBP, int* iModNBP, INFO** infModBP); 

void CopyBpairs(const int iRefN, const INFO *infRefBP, int* iCopyN, INFO** infCopyBP); 
void GetOriginalWeightofRefBP(const int iRefN, const INFO *infRefBP, int* iN, INFO** infBP); 

#endif
