/* N-cubed weighted matching */
/* Implementation of H. Gabow's Ph.D. thesis, Stanford Univ. 1973 */
/* Written by Edward Rothberg  7/85 */
/* For complete details, please refer to the original paper */

/* Send either a Euclidean graph or an adjacency list graph. */
/* Returns an array, the ith entry being the mate of vertex 'i'. */
/* A zero entry indicates an unmatched vertex. */

#ifndef _readgraph_h
#define _readgraph_h

void SetUp(int gptr, int type);
void SetStandard(Graph graph);
void SetEuclid(EuclidGraph graph);
void SetMatrix(MatrixGraph graph);

#endif
